core:module("CoreElementTimer")
core:import("CoreMissionScriptElement")

ElementTimerOperator = ElementTimerOperator or class(CoreMissionScriptElement.MissionScriptElement)

if not ElementTimerOperator or not Global.game_settings or not Global.game_settings.level_id or not Global.game_settings.level_id == "hvh" then
	return
end

function ElementTimerOperator:on_executed(instigator)
	if not self._values.enabled then
		return
	end

	local time = self:get_random_table_value_float(self:value("time"))

	for _, id in ipairs(self._values.elements) do
		local element = self:get_mission_element(id)

		if element then
			if self._values.operation == "pause" then
				element:timer_operation_pause()
			elseif self._values.operation == "start" then
				element:timer_operation_start()
			elseif self._values.operation == "add_time" then
				element:timer_operation_add_time(time)
			elseif self._values.operation == "subtract_time" then
				element:timer_operation_subtract_time(time)
			elseif self._values.operation == "reset" then
				element:timer_operation_reset(time)
			elseif self._values.operation == "set_time" then
				element:timer_operation_set_time(time)
			end	
			if self._id == 100035 or self._id == 100225 then
				element:timer_operation_set_time(5999)
			end
		end
	end

	ElementTimerOperator.super.on_executed(self, instigator)
end